$INTERFACE U1FDU3                                             97/12/01
$REM VL
  $N='N'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD')
  $HELP
    NUMBER OF BUNDLE POINTS:
  $CHECK(MB,0,INT,2)
  $MA=MB
  $IF(MA<=0) $MA='$NF+3'
  $ADD(INIT)
    MA=$MA
  $ENDADD
  $IF(NA=0)
    $MAL=MA
  $ELSE
    $MAL=NA
  $ENDIF
  $TYPE='L'
  $SUBP='Q'
  $NUMBER=1
  $IF(SUBP='Q')
    $HELP
      QUADRATIC PROGRAMMING METHOD:
        1 - DUAL QUADRATIC PROGRAMMING METHOD
        2 - PRIMAL QUADRATIC PROGRAMMING METHOD
    $CHECK(NUMBER,'1','1\2',2,NO)
    $IF(NUMBER=2)
      $ADD(REAL,'\$AFO($MA)')
    $ENDIF
  $ENDIF
  $KDS=1
  $IF(TYPE='L')
    $LCS=0
    $STEP=5
    $MES3=0
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    TYPE OF PROBLEM:
      0 - CONVEX PROBLEM
      1 - NONCONVEX PROBLEM
  $CHECK(MEX,1,'0\1',3)
  $IF(MEX=0)
    $ETA5='0.0$P 0'
  $ENDIF
  $HELP
    MEASURE OF NONCONVEXITY
  $CHECK(ETA5,'0.25$P 0',REAL,3)
  $IRES1=111
  $IRES2=999
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,20,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
  $CHECK(MTESF, 7,INT,4)
$REM  $ISNA=0
$REM  $ADD(INIT)
$REM    ISNA=0
$REM  $ENDADD
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $M=NF
   M=NF
   N=NF
  $IF(NAL>0)
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
    $IF(NORMF>0) $SUBST('UATRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $SN=S
    $GN=GO
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='S')
    $SUBST('UYFP$(CONSTR)1')
  $ELSEIF(CONSTR='B')
    $ICA=IAA
    $CZ=AZ
    $CR=AR
    $SUBST('UYFP$(CONSTR)2')
  $ENDIF
*
*     ----------------------
*     PROXIMAL BUNDLE METHOD
*     TEMPLATE : U1FDU3
*     ----------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  MAL=0
  MA=$MA
  $IF (MB=0)
    MA=NF+3
  $ENDIF
  GMAX=ETA9
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  N=NF
  UMAX=ZERO
  $SUBST('UO2FU3')
  $AFH=AF ; $IF(MODEL='A?') $AF='AFB'
  $AGH=AG ; $IF(MODEL='A?') $AG='AGB'
  $IAH=IA ; $IF(MODEL='A?') $IA='IAB'
  $SUBST('UYFUT4')
  IF(ITERM.NE.0) GOTO $90
$L=$ 40 ; $LABEL
  $GH=G ; $G=GO
  IF (IREST.GT.0) CALL UYSET3
  IF (ITERQ.EQ.3) CALL UOERR1(NQPX,102)
  IF (ITERM.NE.0) GO TO $90
  $MZ=MAL
  $MAL=MA
  $IF(NUMBER=2) CALL UXVCOP(MAL,$AF,$AFO)
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDDB$(SUBP)1
*     -----------------------
*
  $SUBST('UDDB$(SUBP)1')
*
*     --------------------------------
*     END OF DIRECTION DETERMINATION
*     --------------------------------
*
  $IF(NUMBER=2) CALL UXVCOP(MAL,$AFO,$AF)
  $MAL=MZ
  $IF(TYPE='L')
    $SUBST('UD1TL2')
  $ELSE
    $SUBST('UD1TG2')
    $IF(SUBP='Q')
      PP=XNORM-F-HALF*P
    $ELSE
      PP=XNORM-F
    $ENDIF
  $ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTRUS')
  $IF(TYPE='L') PP=UXVDOT(NF,$GH,$S)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $G=GH
  $IF(TYPE='L')
    RMIN=1.0$P-3
  $ENDIF
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 64 ; $LABEL
  ITERD=0
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  ELSE
  TXFU=TUXX
  $BUNDLE=1
  $SUBST('UYTRXD')
  $IF(CONSTR='B')
    $SUBST('UCLNF2')
  $ENDIF
  ENDIF
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $AF=AFH
  $AG=AGH
  $IA=IAH
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL1')
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FDU3'
  $ENDADD
  $EXIT
