$INTERFACE UDGGM4                                             03/12/01
$REM LU
  $CON1='1.0$P-3'
  $CON2='1.0$P 5'
  $CON3='7.5$P 1'
  $CON4='1.0$P-6'
  $CON5='1.0$P 3'
  $CON6='1.0$P-1'
  $IW='IW'
  $IF(HERF='V')
    $SNS=SN
    $GAS=GA
    $GA=G
  $ELSE
    $SOS=SO
    $GSS=GS
    $XSS=XS
    $SO=GS
    $GS=XS
    $XS=XO
  $ENDIF
  $XPS=XP
  $IF(HERF='S')
  $ELSE
    $XP=XS
  $ENDIF
  $LSIZE=10
  $LTYPE=1
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    NUMBER OF LANCZOS STEPS
  $CHECK(MOS3,5,INT,3,NO)
  $IF(MOS3= 1) $MOS3= 5
  $IF(MOS3=-1) $MOS3=-5
  $ADD(INIT)
    MOS3=$MOS3
  $ENDADD
  $HELP
    LOWER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.95$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.10$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(INTEGER,'\MMX\J')
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$XS($NF)&
  \$GS($NF)\$SO($NF)')
  $IF(HERF='D')
    $ADD(REAL,'\$H($M)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='V'
    $POM2=')'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='V')
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,100,INT,4)
    $HELP
      DIRECTION AFTER RESTART:
        0 - NEWTON DIRECTION AFTER RESTART
        1 - STEEPEST DESCENT DIRECTION AFTER RESTART
    $CHECK(MOT1,0,'0\1',2)
    $HELP
      PRECONDITIONING TECHNIQUE:
        0 - PRECONDITIONING IS SUPPRESSED
        1 - PRECONDITIONING BY THE L-BFGS UPDATE (VECTOR FORMULAS)
        2 - PRECONDITIONING BY THE L-BFGS UPDATE (MATRIX FORMULAS)
    $CHECK(MOS2,0,'0\1\2',2)
    $ADD(REAL,'\$X($NF)\$G($NF)')
    $ADD(INTEGER,'\MX\I')
    $IF(CONSTR='C')
      $POM1='U'
      $POM2=',$$IX,KBF)'
      $POM3='C'
    $ELSE
      $POM1='V'
      $POM2=')'
      $POM3='S'
    $ENDIF
    $DEFAULT='0.45$P 0'
    $IF(MOS=1) $DEFAULT='0.25$P 0'
  $ELSEIF(HERF='S')
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=5 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=6 - SSOR PRECONDITIONING
           MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
           MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                      BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,-1,'-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6',1)
    $IF(MOS2=6) $MOS2=-6
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $IF(MOS2=-4) $NOS2=4
    $IF(MOS2=-5) $NOS2=5
    $IF(MOS2=-6) $NOS2=6
    $HELP
      PRECONDITIONING IN ILL-CONTITIONED AND INDEFINITE CASES
        0 - PRECONDITIONING IN BOTH THESE CASES IS SUPPRESSED
        1 - PRECONDITIONING IN ILL-CONDITIONED CASE IS SUPPRESSED
        2 - PRECONDITIONING IS ALWAYS USED
    $CHECK(MOS4,0,'0\1\2',1)
    $IF(NOS2=1)
      $HELP
        TYPE OF THE GILL-MURRAY STRATEGY
          1 - BASIC STRATEGY
          2 - MODIFIED STRATEGY THAT USE ARTIFICIAL SOLUTION VECTOR
      $CHECK(MOS5,1,'1\2',1)
    $ENDIF
    $IF(NOS2=0)
      $ADD(REAL,'\$H($M)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
    $ELSEIF(NOS2=1)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\IW($NF+1)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=2)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=3)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=4)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=5)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ENDIF
    $IF(MOS2<=0) $XP=XS
    $IF(MOS3>=0) $XP=XS
    $ADD(INTEGER,'\NOS2')
    $ADD(INTEGER,'\$IX($NX)')
    $ADD(REAL,'\$XP($NF)\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.9$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='B')
    $ADD(REAL,'\$AH($MAH)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ELSEIF(HERF='L')
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$DR($MF)')
    $ADD(INTEGER,'\$IX($NX)\MX')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ENDIF
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $ADD(REAL,'\UX$(POM1)DOT\UX$(POM1)DEL\UX$(POM1)NOR\UX$(POM1)VDP')
  $ADD(REAL,'\RHO\RHO1\RHO2\SIG\ALF\EPS\TAU\GNORMO')
  $ADD(INTEGER,'\NOS3')
  CALL UOD1D1
  IF (NIT.LE.LIT+1) THEN
  EPS=$EPS6
  GNORMO=$ETA9
  ENDIF
  $IF(HERF='D')
    $N='N'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='V')
    $N='NF'
    IF(IREST.NE.0) THEN
    MX=0
    CALL UYSET3
    IF (MOT1.GT.0) THEN
    CALL UXVNEG($N,$GN,$SN)
    GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
    SNORM=GNORM
    PP=HALF*GNORM
    TUXX='INITIAL '
    TDXX='ST DESC '
    GO TO $90
    ENDIF
    ENDIF
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='S')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
  $ELSEIF(HERF='B')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='L')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ENDIF
  ITERD=-1
  CALL UOERR1('UD$(HERF)GM4',1)
  TDXX='BAD DEC1'
  GO TO $80
  ENDIF
  NOS3=MIN($N,ABS($MOS3))
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  IF (GNORM.GE.$CON5*GNORMO) EPS=$CON4
  GNORMO=GNORM
  INITD=MAX(ABS(INITD),1)
$REM  RHO1=GNORM*GNORM
  RHO1=UX$(POM1)DOT($N,$GN,$GN$POM2
  IF(XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='V')
    XDEL=GNORM
  $ELSE
    $IF(HERF='D')
      RHO2=UXDSMQ($N,$H,$GN,$GN)
    $ELSEIF(HERF='S')
      RHO2=UXSSMQ($N,M,$H,$IH,$JH,$GN,$GN)
    $ELSEIF(HERF='B')
      RHO2=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$GN,$GN)
    $ELSEIF(HERF='L')
      $IF(CONSTR='C')
        CALL UX$(POM1)COP($N,$GN,$SN$POM2
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$SN,$GO)
      $ELSE
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$GN,$GO)
      $ENDIF
    $ENDIF
    IF(RHO2.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(GNORM*GNORM/RHO2)*GNORM
    ENDIF
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  PAR=MIN(EPS,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
    IF (NIT-LIT.GE.NF) PAR=MIN(PAR,$CON4)
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  $IF(HERF='S')
    $IF(NOS2=0)
    $ELSEIF(NOS2=6)
    $ELSEIF(MOS3>0)
    $ELSE
      IF (IDECF.EQ.0) THEN
*
*     INCOMPLETE GILL-MURRAY DECOMPOSITION
*
      INF=0
      ALF=ETA2
      NOS2=ABS($MOS2)
      IF (2*M.GE.$MMAX) THEN
      CALL UOERR2('UD$(HERF)GM4',48,2*M,$MMAX)
      ITERM=-48
      TDXX='LACK SPC'
      GO TO $80
      ENDIF
      $IF(NOS2=1)
        CALL UXVCOP(M,$H,$H(M+1))
        $IF(MOS5=1)
          CALL UXSPTF($N,M,$H(M+1),$IH,$JH,$IW,INF,ALF,SIG)
        $ELSE
          CALL UXSPLF($N,M,$H(M+1),$IH,$JH,$IW,$GO,INF,ALF,SIG)
        $ENDIF
      $ELSEIF(NOS2=2)
        CALL UXSPT2($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,$LSIZE,INF&
,ALF,SIG)
      $ELSEIF(NOS2=3)
        CALL UXSPT3($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,INF,ALF,SIG)
      $ELSEIF(NOS2=4)
        CALL UXSPT4($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$GO,$CON6,INF,ALF,SIG)
      $ELSEIF(NOS2=5)
        CALL UXVCOP(M,$H,$H(M+1))
        CALL UXSPIF($N,M,$H(M+1),$IH,$JH,INF,ALF,SIG,GO)
      $ENDIF
      IF (INF+10.LT.0) THEN
      CALL UOERR1('UD$(HERF)GM4',48)
      ITERM=-48
      TDXX='LACK SPC'
      GO TO $80
      ENDIF
      $IF(MOS4=0)
        IF (INF.NE.0) NOS2=0
      $ELSEIF(MOS4=1)
        IF (INF.LT.0) NOS2=0
      $ENDIF
      NDECF=NDECF+1
      IDECF=1
      ENDIF
      $IF(MOS2>0)
*
*     PRELIMINARY INEXACT SOLUTION
*
        CALL UXVNEG($N,$GN,$XS)
        IF (NOS2.NE.0) THEN
        $IF(NOS2=5)
          CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
        $ELSEIF(NOS2=1)
          CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
        $ELSE
          CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
        $ENDIF
        SNORM=SQRT(UX$(POM1)DOT($N,$XS,$XS$POM2)
        IF (SNORM.LE.XDEL*$CON2) THEN
        CALL UXVCOP($N,$XS,$SN)
        IF (SNORM.LE.XDEL) THEN
        ITERD=2
        TDXX='G-M REG '
        ELSE
        CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
        SNORM=XDEL
        ITERD=3
        TDXX='G-M MAX '
        ENDIF
        CALL UXSSMD($N,M,$H,$IH,$JH,$SN,ONE,$GN,$GO)
        IF (UX$(POM1)DOT($N,$GO,$GO$POM2.LE.1.0$P-2*PAR*RHO1) GO TO $80
        ENDIF
        ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(MOS3=0)
    T=ZERO
  $ELSE
*
*     INCOMPLETE LANCZOS TRIDIAGONALIZATION
*
    CALL UXVCOP($N,$GN,$GS)
    INF=0
    CALL UXVSET($N,ZERO,$SO)
    CALL UXVSCL($N,ONE/UX$(POM1)NOR($N,$GS$POM2,$GS,$GS)
    NRED=0
$11 CONTINUE
    NRED=NRED+1
    IF (NRED.GT.NOS3) GO TO $16
    IF (NRED.GT.1) THEN
    DO $12 J=1,$N
    EL=$GS(J)
    $GS(J)=$SO(J)/EU
    $SO(J)=-EU*EL
$12 CONTINUE
    ENDIF
    $IF(HERF='D')
      CALL UXDSMD($N,$H,$GS,ONE,$SO,$SO)
    $ELSEIF(HERF='V')
      FO=F
      PP=SQRT(ETA0/UX$(POM1)DOT($N,$GS,$GS$POM2)
      LD=MIN(MAX(KDF,KDA)-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      I=ISNA
      ISNA=0
      $SN=GS
      $SUBST('UYTR$(CONSTR)X')
      ASSIGN $15 TO IMD
      GO TO $LMD
$15 CONTINUE
      ISNA=I
      $SN=SNS
      $SUBST('UYTR$(CONSTR)A')
      CALL UXVDIF($N,$G,$GN,$SN)
      F=FO
      CALL UXVSCL($N,ONE/PP,$SN,$SN)
      CALL UXVSUM($N,$SN,$SO,$SO)
    $ELSEIF(HERF='S')
      CALL UXSSMD($N,M,$H,$IH,$JH,$GS,ONE,$SO,$SO)
    $ELSEIF(HERF='B')
      CALL UXBSMD($N,MAH,NA,MA,$AH,$IAG,$JAG,$GS,ONE,$SO,$SO)
    $ELSEIF(HERF='L')
      $IF(CONSTR='C') CALL UX$(POM1)COP($N,$GS,$GS$POM2
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GS,$SN,PAR3&
,$MET)
      CALL UXVSUM($N,$SO,$SN,$SO)
    $ENDIF
    NCGR=NCGR+1
    EL=UX$(POM1)DOT($N,$GS,$SO$POM2
    CALL UX$(POM1)DIR($N,-EL,$GS,$SO,$SO$POM2
    EU=UX$(POM1)NOR($N,$SO$POM2
    IF (EU.LE.ZERO) THEN
    INF=NRED
    GO TO $16
    ENDIF
    $XP(NRED)=EL
    $GO(NRED)=EU
    GO TO $11
$16 CONTINUE
    CALL UXVCOR(NOS3,ETA0,$XP)
    T=ZERO
    RHO2=DEL1*XDEL
    DO $17 NRED=1,10
    T=MIN(T,$CON2)
    IF (T.GE.$CON2) GO TO $18
*
*     SOLUTION OF THE TRIDIAGONAL SYSTEM
*
    ALF=ETA0
    CALL UXVSET(NOS3,T,$GS)
    CALL UXVSUM(NOS3,$XP,$GS,$GS)
    CALL UXVCOP(NOS3,$GO,$SO)
    CALL UXTPGF(NOS3,$GS,$SO,INF,ALF,TAU)
    CALL UXVSET(NOS3,ZERO,$SN)
    S(1)=GNORM
    CALL UXTPGB(NOS3,$GS,$SO,$SN,0)
    RHO=UX$(POM1)DOT(NOS3,$SN,$SN$POM2
    IF (RHO.LE.XDEL**2) GO TO $18
    CALL UXTPGB(NOS3,$GS,$SO,$SN,1)
*
*     MARQUARDT PARAMETER T IS COMPUTED USING THE ONE-DIMENSIONAL
*     NEWTON METHOD
*
    T=T+(RHO/UX$(POM1)VDP(NOS3,$GS,$SN,$SN$POM2)*((SQRT(RHO)-RHO2)/RHO2)
$17 CONTINUE
$18 CONTINUE
    $IF(HERF='S')
      $IF(NOS2=0)
      $ELSEIF(NOS2=6)
      $ELSEIF(MOS3<0)
      $ELSE
*
*     INCOMPLETE GILL-MURRAY DECOMPOSITION
*
        INF=0
        ALF=ETA2
        NOS2=ABS($MOS2)
        IF (2*M.GE.$MMAX) THEN
        CALL UOERR2('UD$(HERF)GM3',48,2*M,$MMAX)
        ITERM=-48
        TDXX='LACK SPC'
        GO TO $80
        ENDIF
        $IF(NOS2=1)
          CALL UXVCOP(M,$H,$H(M+1))
          IF (T.GT.ZERO) CALL UXSSDA($N,M,$H(M+1),$IH,T)
          CALL UXSPTF($N,M,$H(M+1),$IH,$JH,$IW,INF,ALF,SIG)
        $ELSEIF(NOS2=2)
          CALL UXSPT2($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,$LSIZE,INF&
,ALF,SIG)
        $ELSEIF(NOS2=3)
          CALL UXSPT3($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,INF,ALF,SIG)
        $ELSEIF(NOS2=4)
          CALL UXSPT4($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$GO,$CON6,INF,ALF,SIG)
        $ELSEIF(NOS2=5)
          CALL UXVCOP(M,$H,$H(M+1))
          IF (T.GT.ZERO) CALL UXSSDA($N,M,$H(M+1),$IH,T)
          CALL UXSPIF($N,M,$H(M+1),$IH,$JH,INF,ALF,SIG,GO)
        $ENDIF
        IF (INF+10.LT.0) THEN
        CALL UOERR1('UD$(HERF)GM3',48)
        ITERM=-48
        TDXX='LACK SPC'
        GO TO $80
        ENDIF
        $IF(MOS4=0)
          IF (INF.NE.0) NOS2=0
        $ELSEIF(MOS4=1)
          IF (INF.LT.0) NOS2=0
        $ENDIF
        NDECF=NDECF+1
        IDECF=1
        $IF(MOS2>0)
*
*     PRELIMINARY INEXACT SOLUTION
*
          CALL UXVNEG($N,$GN,$XS)
          IF (NOS2.NE.0) THEN
          $IF(NOS2=5)
            CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
          $ELSEIF(NOS2=1)
            CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
          $ELSE
            CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
          $ENDIF
          SNORM=SQRT(UX$(POM1)DOT($N,$XS,$XS$POM2)
          IF (SNORM.LE.XDEL*$CON2) THEN
          CALL UXVCOP($N,$XS,$SN)
          IF (SNORM.LE.XDEL) THEN
          ITERD=2
          TDXX='G-M REG '
          ELSE
          CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
          SNORM=XDEL
          ITERD=3
          TDXX='G-M MAX '
          ENDIF
          CALL UXSSMD($N,M,$H,$IH,$JH,$SN,ONE,$GN,$GO)
          IF (UX$(POM1)DOT($N,$GO,$GO$POM2.LE.1.0$P-2*PAR*RHO1) GO TO $80
          ENDIF
          ENDIF
        $ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
*
*     CG INITIATION
*
  RHO=RHO1
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$GS)
  $IF(HERF='V')
    $IF(MOS2=1)
      CALL UXVCOP($N,$GS,$XS)
      B=UX$(POM1)DOT($N,$XM,$GM$POM2
      IF (B.GT.ZERO) THEN
      $U1(1)=ONE/B
      CALL UXDR$(POM3)B($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
      A=UX$(POM1)DOT($N,$GM,$GM$POM2
      IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$XS,$XS)
      CALL UXDR$(POM3)F($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
      ENDIF
    $ELSEIF(MOS2=2)
      CALL UXLSIM($N,MX,$XM,$GM,$GR,$HR,$IHR,$U1,$U2,$GS,$XS,PAR3,MET)
    $ELSE
      CALL UXVNEG($N,$GS,$XS)
    $ENDIF
    RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
  $ELSEIF(HERF='S')
    $IF(NOS2=0)
      CALL UXVNEG($N,$GN,$XS)
    $ELSEIF(NOS2=6)
      CALL UXVNEG($N,$GN,$XS)
      CALL UXSPPB($N,M,$H,$IH,$JH,$XS)
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
    $ELSEIF(MOS2>0)
      IF (NOS2.GT.0) THEN
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
      ELSE
      CALL UXVNEG($N,$GN,$XS)
      ENDIF
    $ELSE
      CALL UXVNEG($N,$GN,$XS)
      IF (NOS2.NE.0) THEN
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
      $ENDIF
      RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
      ENDIF
    $ENDIF
  $ELSE
    CALL UXVNEG($N,$GN,$XS)
  $ENDIF
  MMX=$N+3
  $IF(MCGR>0)
    MMX=MIN(MMX,$MCGR)
  $ENDIF
  NRED=0
$20 CONTINUE
  NRED=NRED+1
  IF(NRED.GT.MMX) GO TO $40
  $IF(HERF='D')
    IF (T.GT.ZERO) THEN
    CALL UXDSMD($N,$H,$XS,T,$XS,$GO)
    ELSE
    CALL UXDSMM($N,$H,$XS,$GO)
    ENDIF
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XS,$XS$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SN=XS
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    ISNA=I
    $SN=SNS
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    IF (T.GT.ZERO) CALL UX$(POM1)DIR($N,T,$XS,$GO,$GO$POM2
  $ELSEIF(HERF='S')
    IF (T.GT.ZERO) THEN
    CALL UXSSMD($N,M,$H,$IH,$JH,$XS,T,$XS,$GO)
    ELSE
    CALL UXSSMM($N,M,$H,$IH,$JH,$XS,$GO)
    ENDIF
  $ELSEIF(HERF='B')
    IF (T.GT.ZERO) THEN
    CALL UXBSMD($N,MAH,NA,MA,$AH,$IAG,$JAG,$XS,T,$XS,$GO)
    ELSE
    CALL UXBSMM($N,MAH,NA,MA,$AH,$IAG,$JAG,$XS,$GO)
    ENDIF
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$XS,$XS$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XS,$GO,PAR3,$MET)
    IF (T.GT.ZERO) CALL UX$(POM1)DIR($N,T,$XS,$GO,$GO$POM2
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XS,$GO$POM2
  TDXX='CG  MAX1'
  IF (ALF.LE.ZERO) GO TO $60
  ALF=RHO/ALF
  RHO2=SQRT(UX$(POM1)DEL($N,ALF,$XS,$SN$POM2)
  TDXX='CG  MAX2'
  IF (RHO2.GE.XDEL) GO TO $60
*
*     CG STEP
*
  TDXX='CG  STEP'
  CALL UX$(POM1)DIR($N, ALF,$XS,$SN,$SN$POM2
  CALL UX$(POM1)DIR($N,-ALF,$GO,$GS,$GS$POM2
  SNORM=RHO2
  RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $50
  IF (NRED.GE.$N+3) GO TO $40
  $IF(HERF='V')
    $IF(MOS2=1)
      IF (B.GT.ZERO) THEN
      CALL UXVCOP($N,$GS,$GO)
      CALL UXDR$(POM3)B($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
      IF (A.GT.ZERO) CALL UXVSCL($N,B/A,$GO,$GO)
      CALL UXDR$(POM3)F($N,MX,$XM,$GM,$U1,$U2,$XS$POM2
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
      ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
      ENDIF
    $ELSEIF(MOS2=2)
      CALL UXLSIM($N,MX,$XM,$GM,$GR,$HR,$IHR,$U1,$U2,$GS,$GO,PAR3,MET)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
    $ENDIF
  $ELSEIF(HERF='S')
    $IF(NOS2=0)
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
    $ELSEIF(NOS2=6)
      CALL UXVCOP($N,$GS,$GO)
      CALL UXSPPB($N,M,$H,$IH,$JH,$GO)
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
    $ELSE
      IF (NOS2.NE.0) THEN
      CALL UXVCOP($N,$GS,$GO)
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$GO,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$GO,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$GO,0)
      $ENDIF
      RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GO,$XS$POM2
      ELSE
      ALF=RHO2/RHO
      CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
      ENDIF
    $ENDIF
  $ELSE
    ALF=RHO2/RHO
    CALL UX$(POM1)DIR($N,ALF,$XS,$GS,$XS$POM2
  $ENDIF
  RHO=RHO2
  GO TO $20
$40 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$50 CONTINUE
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  ITERD=2
  TDXX='CG  STEP'
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$60 CONTINUE
  RHO1=UX$(POM1)DOT($N,$XS,$SN$POM2
  RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$XS,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$80 CONTINUE
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$SN,$SN$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $85 TO IMD
    GO TO $LMD
$85 CONTINUE
    ISNA=I
    $SUBST('UYTR$(CONSTR)A')
    CALL UX$(POM1)DIF($N,$G,$GN,$GO$POM2
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    PP=HALF*UX$(POM1)DOT($N,$SN,$GO$POM2
$90 CONTINUE
  $ELSEIF(HERF='S')
    PP=UXSSMQ($N,M,$H,$IH,$JH,$SN,$SN)*HALF
  $ELSEIF(HERF='B')
    PP=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$SN,$SN)*HALF
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$SN,$SN$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
    PP=UXVDOT($N,$SN,$GO)*HALF
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='V')
    $GA=GAS
  $ELSE
    $SO=SOS
    $GS=GSS
    $XS=XSS
  $ENDIF
  $XP=XPS
  $ADD(INIT)
    NDXX='UD$(HERF)GM4'
  $ENDADD
  $EXIT
