$INTERFACE UDDMM1                                             91/12/01
$REM LU
  $CON0='8.0$P 0'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$GO($NF)')
  $ADD(REAL,'\B1\B2')
  $ADD(REAL,'\UXVDOT')
  $IDECF=0
  CALL UOD1D1
  IF (IDECF.LT.0) IDECF=0
  IF (IDECF.NE.0) THEN
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)MM1',1)
  GO TO $50
  ENDIF
  $IF(HERF='D')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $GOS=GO
      $GO=GN
      $GSS=GS
      $GS=GN
    $ENDIF
    $ADD(REAL,'\$H($M)\$B($M)\$GS($NF)')
    $ADD(REAL,'\UXDSMQ')
    $HELP
       TYPE OF DECOMPOSITION
         0 - GILL-MURRAY DECOMPOSITION
         1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
         2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,0,'0\1\2',2)
    $IF(MOS2=0)
    $ELSE
      $IF(MOS2=1)
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
        $ADD(REAL,'\$XO($NF)')
      $ELSE
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
    $ENDIF
    $N='N'
  $ELSEIF(HERF='S')
    $GOS=GO
    $GO=GN
    $ADD(REAL,'\$H($MMAX)\$GN($NF)\$SN($NF)\$XO($NF)\$GS($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$WN11($NF+1)')
    $ADD(INTEGER,'\$WN12($NF+1)\$PERM($NF)')
    $ADD(REAL,'\UXSSMQ')
    $N='NF'
    MM=$IH($N+1)-1
  $ENDIF
  $IF(MOS1>0)
    IF (IDIR.EQ.0) CALL UXDSMX($N,$H,$GS)
  $ENDIF
  CALL UXVCOP($N,$GN,$GO)
  $IF(MOS1>0)
    CALL UXVMUL($N,$GS,$GO,$GO,1)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GO,$GO))
  INITD=MAX(ABS(INITD),1)
  $IF(HERF='S')
    CALL UXVSFP($N,$PERM,$GO,$GS)
  $ENDIF
  NRED=1
$10 CONTINUE
  IF (ITERS.EQ.2) THEN
  ELSE IF (ITERS.LT.2) THEN
*
*     EXPANSION OF THE MARQUARDT PARAMETER
*
  IF(T.LE.ZERO) THEN
  E=HALF*E
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGI($N,$B)
    $ELSEIF(MOS2=1)
      CALL UXDLGI($N,$B,$IH,$XO)
    $ELSE
      CALL UXDSGI($N,$B,$IH)
    $ENDIF
    CALL UXDSMB($N,$B,B1,B2)
    TO=ONE/MIN(B1,B2)
  $ELSEIF(HERF='S')
    CALL UXSPCN($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,TO,0)
  $ENDIF
  T=TO
  ENDIF
  T=MAX(E*T,SQRT(T))
  ELSE IF (ITERS.GT.2) THEN
*
*     REDUCTION OF THE MARQUARDT PARAMETER
*
  T=HALF*T
  IF(T.LT.TO) T=ZERO
  ENDIF
*
*     MODIFICATION AND GILL-MURRAY DECOMPOSITION
*
  IF(T.LE.ZERO) TO=ZERO
  E=ETA2
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGC($N,$H,$B,E,T,NDECF)
    $ELSE
      CALL UXD$(LET)GC($N,$H,$B,$IH,$SN,E,T,NDECF$ART
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $50
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCA($N,MM,MH,MMAX,$H,$IH,$JH,T)
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GS,INF&
,E,B1)
  $ENDIF
  IF (TO.LE.ZERO) TO=T
*
*     NEWTON OR MARQUARDT STEP
*
  CALL UXVNEG($N,$GO,$SN)
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGB($N,$B,$SN,0)
    $ELSE
      CALL UXD$(LET)GB($N,$B,$IH,$SN,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,0)
  $ENDIF
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  IF(T.LE.TO) THEN
  ITERD=1
  TDXX='NEWTON  '
  ELSE
  ITERD=5
  TDXX='MARQ.   '
  ENDIF
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
  $ELSEIF(HERF='S')
    CALL UXVSBP($N,$PERM,$GN,$GS)
    CALL UXVSBP($N,$PERM,$SN,$GS)
    IF (MOT2.EQ.0) PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
  $ENDIF
  CALL UOD1D6(T,TO,E,SNORM)
  IF(SNORM.GT.XMAX) THEN
  E=$CON0
  ITERS=0
  NRED=NRED+1
  GO TO $10
  ENDIF
  $IF(MOS1>0)
    CALL UXVMUL($N,$GS,$SN,$SN,1)
  $ENDIF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(MOS1=0)
      $GO=GOS
      $GS=GSS
    $ENDIF
  $ELSEIF(HERF='S')
    $GO=GOS
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)MM1'
  $ENDADD
  $EXIT
