$INTERFACE UDSLZ3                                             03/12/01
$REM LU
  $CON1='1.0$P-3'
  $CON2='9.0$P-1'
  $CON4='1.0$P-8'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
      2 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1\2',4)
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF1,'1.5$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=5)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'5.0D-5',REAL,4)
  $ADD(REAL,'\$CG($MC)\$CF($NC)\$GC($NF)\$G($NF)&
  \$S($NF+$NC)\$XO($NF)\$GO($NF)\$XS($NF)\$GS($NF)\$CZ($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)&
  \$IX($NX)\$WN11($NF+1)\$WN12($NF+1)')
  $ADD(REAL,'\RHO\RHO1\RHO2\ALF\TEMP\TEMP1\TEMP2')
  $ADD(REAL,'\UX$(POM1)DOT\UXVDOT\UXWDOT')
  $ADD(INTEGER,'\I\K\L\MMX\IPOM\KPOM')
  $ADD(LOGICAL,'\L1')
  $IF(MEP=1)
    $ADD(REAL,'\$CP($NC)')
  $ELSEIF(NOS2=1)
    $IF(MD>0)
      $ADD(REAL,'\$CP($NC)')
    $ENDIF
  $ENDIF
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='S')
    M=$IH(NF+1)-1
  $ELSEIF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ELSEIF(HERF='V')
    $GRAD=GN
    $SNS=SN
    $GAS=GA
    $XOS=XO
    $GCS=GC
    $GC=GP
  $ENDIF
  IPOM=0
*
*     CONSTRUCTION OF PRECONDITIONER
*
  $LZI=$90
  $SUBST('UDSLZI')
  INITD=MAX(ABS(INITD),1)
*
*     RANGE SPACE (VERTICAL) DIRECTION
*
  $JOB=MOS2
  $SUBST('UDSLZR')
*
*     CG INITIATION
*
  $IF(NOS2=1)
    $FILE=S
  $ELSE
    CALL UXVCOP($N,$S,$XP)
    $FILE=XP
  $ENDIF
  $IF(HERF='D')
    CALL UXDSMD($N,$H,$S,ONE,$G,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMD($N,M,$H,$IH,$JH,$S,ONE,$G,$GO)
  $ELSEIF(HERF='L')
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$S,$GO,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$S,$GO,PAR3,MET1)
    $ENDIF
    CALL UXVSUM($N,$GO,$G,$GO)
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$S,$GO)
    GO TO $25
    ENDIF
    FO=F
    PP=UX$(POM1)DOT($N,$S,$S$POM2
    IF (PP.EQ.ZERO) THEN
    CALL UXVCOP($N,$S,$GO)
    GO TO $25
    ENDIF
    PP=SQRT(ETA0/PP)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=S
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $20 TO IMD
    GO TO $LMD
$20 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$25 CONTINUE
    CALL UXVSUM($N,$GO,$GN,$GO)
  $ENDIF
  CALL UXVNEG($N,$GO,$XS)
*
*     CG PRECONDITIONING
*
  $SUBST('UDSLZP')
  CALL UXVCOP($N,$GO,$XO)
  RHO1=UX$(POM1)DOT($N,$GO,$XS$POM2
  RHO=RHO1
  PAR=MIN(EPS6,RHO1)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE($N-$NN)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  KPOM=0
  MMX=MIN(20,2*($N-$NN))
$REM  MMX=2*($N-$NN)
*
*     CG ITERATIONS
*
  DO $50 NRED=1,MMX
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XO,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XO,$GO)
  $ELSEIF(HERF='L')
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XO,$GO,PAR3&
,$MET)
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$XO,$GO)
    GO TO $35
    ENDIF
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XO,$XO$POM2)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=XO
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$35 CONTINUE
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XO,$GO$POM2
  IF (ALF.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UD$(HERF)LZ3',5)
  GO TO $90
  ENDIF
*
*     CG STEP
*
  TDXX='CG  STEP'
  ALF=RHO/ALF
  CALL UX$(POM1)DIR($N, ALF,$XO,$FILE,$FILE$POM2
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  CALL UXVNEG($N,$XS,$GO)
*
*     CG PRECONDITIONING
*
  $SUBST('UDSLZP')
  RHO2=UX$(POM1)DOT($N,$GO,$XS$POM2
  $IF(NOS2=2)
    CALL UXVCOP($N,$XP,$S)
  $ENDIF
*
*     TERMINATION CRITERION
*
  L1=NRED.GE.MMX
  IF (RHO2.LE.PAR*RHO1) L1=.TRUE.
*
*     TEST FOR DESCENT DIRECTION
*
  $LZT=$60
  $SUBST('UDSLZT')
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR($N,ALF,$XO,$GO,$XO$POM2
  RHO=RHO2
$50 CONTINUE
  TDXX = 'MAX ITER'
  $IF(MOS1=2)
    $ADD(REAL,'\UXVNOR\UXUNOR')
    IF (IREST.EQ.0) THEN
    IF (UXVNOR($NN,$S($N+1)).LT.TEN*UX$(POM1)NOR($N,$S$POM2) THEN
    KPOM=1
    P=ZERO
    ENDIF
    ENDIF
  $ENDIF
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$60 CONTINUE
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  $SUBST('UDSLZD')
$90 CONTINUE
  $IF(HERF='V')
    CALL UXVCOP(NF,$XV,$X)
    CALL UXVCOP(NF,$GN,$G)
    $GC=GCS
  $ENDIF
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UDSLZ3'
  $ENDADD
  $EXIT
