$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU22                                    01/12/98  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION  - COMBINED TUNNELING AND        +
$REM +                                 RANDOM START METHOD           +
$REM +---------------------------------------------------------------+
      $SET(PENALFNC)
         IF (TUNEL) THEN
           $IF(KD=0)
             CALL UG0F01(NF,F,X,FSET(NLMIN),XSET((NLMIN-1)*NF+1),IALF)
           $ELSE
             CALL UG1F01(NF,F,X,FSET(NLMIN),XSET((NLMIN-1)*NF+1),$GF&
            ,IALF,KD)
           $ENDIF
         ENDIF
      $ENDSET
      $HELP
        MAX. NUMBER OF LOCAL MINIMA
      $CHECK(MNLMIN,'50+10*$NF',STR,3,NO)
      $HELP
        MAX. VALUE OF PARAMETER ALFA OF TUNNELING FUNCTION
      $CHECK(MAXALFA,8,INT,3,NO)
     $HELP
       MAX. NUMBER OF RANDOM RESTARTS
     $CHECK(MNRND,'NF*3+3',STR,3,NO)
      $SUBST('UZSRND')
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)\FSET($MNLMIN)&
           \XSET($NF*($MNLMIN))')
      $ADD(INTEGER,'\NLMIN\IALF')
      $ADD(LOGICAL,'\TUNEL')
      $TEXT='UGFU22'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU22(NF,X,XL,XU,FSET,XSET,TUNEL,NLMIN,IALF,F,FMIN)
      GOTO ($20,$10) ISB+1
$L=$10; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$20; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU22(NF,X,XL,XU,FSET,XSET,TUNEL,NLMIN,IALF,F,FMIN)
      INTEGER NF,NLMIN,IALF
      $FLOAT X($NF),XL($NF),XU($NF),FSET($MNLMIN),XSET($NF*($MNLMIN)),
     &       F,FMIN
      LOGICAL TUNEL
      $INCLUDE('UMCOMM')
      REAL UNRAN$RGTYPE
      $FLOAT FMIN2
      INTEGER MNLMIN,INDX($MNLMIN),I,NRND
      INTEGER NITT,NFVT,NFGT,NFHT,NLMST,IDUM
      LOGICAL UYDMIN
      SAVE FMIN2
      SAVE MNLMIN,INDX,NRND,NITT,NFVT,NFGT,NFHT,NLMST
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        IDUM=-1
        NLMST=0
        NLMIN=0
        MNLMIN=$MNLMIN
        TUNEL=.FALSE.
        X(1)=UNRAN$RGTYPE(IDUM)
      ENDIF
      GOTO (20,50), ISP(NS)
   20 CONTINUE
      IDUM=1
      DO 30 I=1,NF
        X(I)=(XU(I)-XL(I))*UNRAN$RGTYPE(IDUM)+XL(I)
   30 CONTINUE
  *
  *     LOCAL OPTIMIZATION PHASE
  *
   40 CONTINUE
      FMIN2=FMIN
      IF (TUNEL) FMIN=0.0$P 0
  *
  *     LOCAL OPTIMIZATION
  *
      CALL UYCLST
      CALL UYSET0(1,2)
      RETURN
   50 CONTINUE
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NLMST=NLMST+1
      FMIN=FMIN2
      IF (TUNEL) THEN
        IF (F.GT.0) THEN
          IF (NRND.LT.$MNRND) THEN
            NRND=NRND+1
          ELSEIF (IALF.LT.$MAXALFA) THEN
            IALF=IALF+1
            NRND=0
          ELSE
            GOTO 70
          ENDIF
        ELSE
          TUNEL=.FALSE.
          GOTO 40
        ENDIF
      ELSE
        I=1
   60   CONTINUE
        IF (I.LE.NLMIN) THEN
          IF (UYDMIN(NF,F,X,FSET(I),XSET((I-1)*NF+1))) THEN
            I=I+1
            GOTO 60
          ENDIF
        ENDIF
        IF (I.GT.NLMIN.AND.ITERM.GE.1.AND.ITERM.LE.10) THEN
          NLMIN=NLMIN+1
          CALL UXVCOP(NF,X,XSET((NLMIN-1)*NF+1))
          FSET(NLMIN)=F
          CALL UO3FU4(NITT,NFVT,NLMIN,F)
          IF (NLMIN.EQ.MNLMIN) GOTO 70
          IALF=5
        ELSEIF(IALF.LT.$MAXALFA) THEN
          IALF=IALF+1
        ELSE
          GOTO 70
        ENDIF
        NRND=0
        TUNEL=.TRUE.
      ENDIF
      GOTO 20
  *
  *     PRINT OF RESULTS
  *
   70 CONTINUE
      CALL UYINDX(NLMIN,FSET,INDX)
      F=FSET(1)
      CALL UXVCOP(NF,XSET,X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      CALL UYEPI1(-1)
      END
$ENDADD
