$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZLMIN                                     16/12/04 +
$REM + LU                                                            +
$REM + PURPOSE:  LOCAL MINIMIZATION                                  +
$REM +---------------------------------------------------------------+

$POM=1
$IF(NC>0) $NN='NC'
$IF(MODEL='AM')
  $IF(NC=0)
    $IF($DEF(CLASS))
      $IF(CLASS='H?') $FORM='NO'
      $IF(CLASS='B?') $FORM='NO'
    $ENDIF
    $IF(JACA='S')
      $HELP
        FORM OF METHODS:
          SI - PRIMAL-DUAL INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
          SP - PRIMAL INTERIOR POINT METHODS
          SM - SMOOTHING METHODS
          NO - GENERAL UNCONSTRAINED METHODS
      $CHECK(FORM,'SP','SI\SF\SP\SM\NO\N',2,NO)
      $IF(FORM='N') $FORM='NO'
      $IF(FORM='SI')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SF')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'  /
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SP')
        $IF($DEF(HESF))
        $ELSE
          $HESF='S'
        $ENDIF
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SM')
        $IF($DEF(HESF))
        $ELSE
          $HESF='S'
        $ENDIF
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ENDIF
    $ELSE
      $DEFAULT='NO'
      $IF(NF<201) $DEFAULT='SL'
      $HELP
        FORM OF METHODS:
          SL - SEQUENTIAL LINEAR AND QUADRATIC PROGRAMMING 
               METHODS FOR COMPOSITE NONSMOOTH PROBLEMS
          SQ - SEQUENTIAL QUADRATIC PROGRAMMING METHODS FOR
               NONLINEAR PROGRAMMING PROBLEMS
          NO - GENERAL UNCONSTRAINED METHODS
      $CHECK(FORM,DEFAULT,'SL\SQ\NO\N',2,NO)
      $IF(FORM='N') $FORM='NO'
      $IF(FORM='SL')
        $HELP
          CLASS OF METHODS:
            LP - SEQUENTIAL LINEAR PROGRAMMING METHODS
            VM - SEQUENTIAL VARIABLE METRIC METHODS
            MN - SEQUENTIAL MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','LP\VM\MN',2,NO)
      $ELSEIF(FORM='SQ')
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','VM\MN',2,NO)
      $ENDIF
    $ENDIF
  $ELSEIF(NC=NCL)
    $IF($DEF(CLASS))
      $IF(CLASS='H?') $FORM='NO'
      $IF(CLASS='B?') $FORM='NO'
    $ENDIF
    $IF(JACA='D')
      $HELP
        FORM OF METHODS:
          SL - SEQUENTIAL LINEAR AND QUADRATIC PROGRAMMING 
               METHODS FOR COMPOSITE NONSMOOTH PROBLEMS
          SQ - SEQUENTIAL QUADRATIC PROGRAMMING METHODS FOR
               NONLINEAR PROGRAMMING PROBLEMS
          NO - GENERAL UNCONSTRAINED METHODS
      $CHECK(FORM,'SL','SL\SQ\NO\N',2,NO)
      $IF(FORM='N') $FORM='NO'
      $IF(FORM='SL')
        $HELP
          CLASS OF METHODS:
            LP - SEQUENTIAL LINEAR PROGRAMMING METHODS
            VM - SEQUENTIAL VARIABLE METRIC METHODS
            MN - SEQUENTIAL MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','VM\MN',2,NO)
      $ELSEIF(FORM='SQ')
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','VM\MN',2,NO)
      $ENDIF
    $ENDIF
  $ELSE
    $IF(JACC='S')
      $HELP
        FORM OF METHODS:
          SI - PRIMAL-DUAL INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
      $CHECK(FORM,'SI','SI\SF',2,NO)
      $IF(FORM='SI')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SF')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ENDIF
    $ELSE
      $FORM='SQ'
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          MN - MODIFIED NEWTON METHODS
      $CHECK(CLASS,'VM','VM\MN',2,NO)
    $ENDIF
  $ENDIF
  $IF (FORM='NO') $POM=0
$ELSEIF(MODEL='AA')
  $IF(NC=0)
    $IF($DEF(CLASS))
      $IF(CLASS='H?') $FORM='NO'
      $IF(CLASS='B?') $FORM='NO'
    $ENDIF
    $IF(JACA='S')
      $HELP
        FORM OF METHODS:
          SE - EQUALITY CONSTRAINED METHODS 
          SI - PRIMAL-DUAL INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
          SP - PRIMAL INTERIOR POINT METHODS
          SM - SMOOTHING METHODS
          NO - GENERAL UNCONSTRAINED METHODS
      $CHECK(FORM,'SP','SE\SI\SF\SP\SM\NO\N',2,NO)
      $IF(FORM='N') $FORM='NO'
      $IF(FORM='SE')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SI')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SF')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SP')
        $IF($DEF(HESF))
        $ELSE
          $HESF='S'
        $ENDIF
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SM')
        $IF($DEF(HESF))
        $ELSE
          $HESF='S'
        $ENDIF
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ENDIF
    $ELSE
      $DEFAULT='NO'
      $IF(NF<201) $DEFAULT='SQ'
      $HELP
        FORM OF METHODS:
          SQ - SEQUENTIAL QUADRATIC PROGRAMMING METHODS FOR
               NONLINEAR PROGRAMMING PROBLEMS
          NO - GENERAL UNCONSTRAINED METHODS
      $CHECK(FORM,DEFAULT,'SQ\NO\N',2,NO)
      $IF(FORM='N') $FORM='NO'
      $IF(FORM='SQ')
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','VM\MN',2,NO)
      $ENDIF
    $ENDIF
  $ELSE
    $IF(JACC='S')
      $HELP
        FORM OF METHODS:
          SI - PRIMAL-DUAL INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
      $CHECK(FORM,'SI','SI\SF',2,NO)
      $IF(FORM='SI')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SF')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ENDIF
    $ELSE
      $FORM='SQ'
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          MN - MODIFIED NEWTON METHODS
      $CHECK(CLASS,'VM','VM\MN',2,NO)
    $ENDIF
  $ENDIF
  $IF (FORM='NO') $POM=0
$ELSEIF(NC>NCL)
$ELSE
  $POM=0
$ENDIF
$IF(POM>0)
  $IF(MODEL='AM')
  $ELSEIF(MODEL='AA')
  $ELSEIF(JACC='S')
    $IF($DEF(HESF))
    $ELSE
      $HESF='S'
    $ENDIF
    $IF(NCC=0)
      $DEFAULT='SI'
      $IF($DEF(NCE))
        $IF(NCE=NC) $DEFAULT='SE'
      $ENDIF
      $HELP
        FORM OF METHODS:
          SE - INEXACT SEQUENTIAL QUADRATIC PROGRAMMING METHODS
               METHODS FOR EQUALITY CONSTRAINED PROBLEMS
          SI - PRIMAL-DUAL INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
          SN - PRIMAL INTERIOR POINT METHODS
      $CHECK(FORM,DEFAULT,'SQ\SE\SI\SF\SN\SP',2,NO)
      $HELP
        FORM OF METHODS:
          SQ - SEQUENTIAL QUADRATIC PROGRAMMING METHODS
             WITH L1 EXACT MERIT FUNCTION
          SE - INEXACT SEQUENTIAL QUADRATIC PROGRAMMING METHODS
               METHODS FOR EQUALITY CONSTRAINED PROBLEMS
          SI - INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
          SS - SLACK VARIABLES METHODS
          SP - PRIMAL INTERIOR POINT METHODS
      $CHECK(FORM,DEFAULT,'SQ\SE\SI\SF\SS\SN\SP',2,NO)
      $IF(FORM='SQ')
        $IF($DEF(HESF))
        $ELSE
          $HESF='S'
        $ENDIF
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,'VM','VM\MN',2,NO)
      $ELSEIF(FORM='SE')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED NEWTON METHOD
        $CHECK(CLASS,DEFAULT,'VM\VL\MN\TN',2,NO)
      $ELSEIF(FORM='SI')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED NEWTON METHOD
        $CHECK(CLASS,DEFAULT,'VM\VL\MN\TN',2,NO)
      $ELSEIF(FORM='SF')
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED NEWTON METHOD
        $CHECK(CLASS,DEFAULT,'VM\VL\MN\TN',2,NO)
      $ELSEIF(FORM='SS')
        $CLASS='MN'
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $CLASS='MN'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\VL\MN',2,NO)
      $ELSEIF(FORM='SN')
        $CLASS='MN'
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\MN',2,NO)
      $ELSEIF(FORM='SP')
        $CLASS='MN'
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'VM\MN',2,NO)
      $ENDIF
    $ELSE
      $FORM='SI'
      $HELP
        FORM OF METHODS:
          SI - INTERIOR POINT METHODS
          SF - FISHER-BURMEISTER SEMISMOOTH EQUATION METHODS
      $CHECK(FORM,'SI','SI\SF',2,NO)
      $IF(FORM='SI')
        $HELP
          METHOD FOR COMPLEMENTARITY CONSTRAINTS HANDLING:
            P - L1 EXACT PENALTY FUNCTION WITH SLACK VECTORS
            R - SIMPLE RELAXATION TECHNIQUE
        $CHECK(COMPL,'P','P\R',2,NO)
        $DEFAULT='MN'
$REM        $IF(IADA>0) $DEFAULT='VM'
        $IF(HESF<>'S') $DEFAULT='VL'
        $HELP
          CLASS OF METHODS:
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED NEWTON METHOD
        $CHECK(CLASS,DEFAULT,'VM\VL\MN\TN',2,NO)
      $ELSEIF(FORM='SF')
      $ENDIF
    $ENDIF
  $ELSE
    $HESF='D'
    $FORM='SQ'
    $HELP
      FORM OF METHODS:
        SQ - SEQUENTIAL QUADRATIC PROGRAMMING METHODS
             WITH L1 EXACT MERIT FUNCTION
        SM - SEQUENTIAL QUADRATIC PROGRAMMING METHODS
             WITH MINIMAX FORMULATION
    $CHECK(FORM,'SQ','SQ\SM',2,NO)
    $IF(FORM='SM') $CLASS='VM'
    $IF(FORM='SQ')
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          MN - MODIFIED NEWTON METHODS
      $CHECK(CLASS,'VM','VM\MN',2,NO)
    $ENDIF
  $ENDIF
  $IF(CLASS='VL') $HESF='NO'
$ELSEIF(MODEL='FF')
  $IF(KSF=3)
    $IF(HESF='NO')
      $DEFAULT='BL'
      $IF(NF<50) $DEFAULT='BM'
    $ELSE
      $DEFAULT='BV'
      $IF(NF<20) $DEFAULT='BM'
    $ENDIF
    $HELP
      CLASS OF METHODS:
        VM - VARIABLE METRIC METHODS
        BM - PROXIMAL BUNDLE METHODS
        BN - BUNDLE-NEWTON METHODS
        BV - VARIABLE METRIC METHODS FOR NONSMOOTH FUNCTIONS
        BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
             NONSMOOTH FUNCTIONS
    $CHECK(CLASS,DEFAULT,'VM\BM\BN\BV\BW\BL',2,NO)
    $IF(CLASS='BM') $HESF='NO'
    $IF(CLASS='BL') $HESF='NO'
  $ELSEIF(HESF='NO')
    $IF(KDF=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
      $CHECK(CLASS,'CD','HM\CD\VL\VN\VP\VS\VR',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          TN - TRUNCATED MODIFIED NEWTON METHODS
      $CHECK(CLASS,'CD','CD\VL\VN\VP\VS\VR\TN',2,NO)
    $ENDIF
  $ELSEIF(HESF='D')
    $IF(KDF=2)
      $DEFAULT='MN'
    $ELSEIF(KCF=1)
      $DEFAULT='CD'
      $IF(NF<201) $DEFAULT='VM'
    $ELSEIF(KCF=2)
      $DEFAULT='CD'
      $IF(NF<301) $DEFAULT='VM'
    $ELSE
      $DEFAULT='CD'
      $IF(NF<401) $DEFAULT='VM'
    $ENDIF
    $IF(KDF=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          BM - PROXIMAL BUNDLE METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,DEFAULT,'HM\CD\VM\VL\VN\VP\VS\VR\MN\BM\BV\BW',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          TN - TRUNCATED MODIFIED NEWTON METHODS
          BM - PROXIMAL BUNDLE METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN\BM\BV\BW\HM',2,NO)
    $ENDIF
  $ELSEIF(HESF='S')
    $IF(KBC>0)
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          MN - MODIFIED NEWTON METHODS
      $CHECK(CLASS,'VM','CD\VM\MN',2,NO)
    $ELSE
      $IF(KDF=2)
        $DEFAULT='MN'
      $ELSEIF(KCF=1)
        $DEFAULT='CD'
        $IF(NF<50) $DEFAULT='MN'
      $ELSE
        $DEFAULT='MN'
      $ENDIF
      $IF(KDF=0)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN',2,NO)
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(CLASS='HM') $HESF='NO'
  $IF(CLASS='CD') $HESF='NO'
  $IF(CLASS='VL') $HESF='NO'
  $IF(CLASS='VP') $HESF='NO'
  $IF(CLASS='VS') $HESF='NO'
  $IF(CLASS='VR') $HESF='NO'
  $IF(CLASS='TN') $HESF='NO'
$ELSEIF(MODEL='FL')
  $IF(NC>0)
    $IF(JACC='S')
      $HELP
        CLASS OF METHODS:
          LP - LINEAR PROGRAMMING ACTIVE SET METHODS
          LI - LINEAR PROGRAMMING INTERIOR POINT METHODS
      $CHECK(CLASS,'LP','LP\LI',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          LP - LINEAR PROGRAMMING ACTIVE SET METHODS
      $CHECK(CLASS,'LP','LP',2,NO)
    $ENDIF
  $ELSE
    $HELP
      CLASS OF METHODS:
        CD - CONJUGATE DIRECTION METHODS
    $CHECK(CLASS,'CD','CD',2,NO)
    $TYPE='L'
    $DECOMP='C'
    $NUMBER=1
    $MET=0
  $ENDIF
  $HESF='NO'
$ELSEIF(MODEL='FQ')
  $IF(NC>0)
    $HELP
      CLASS OF METHODS:
        QP - QUADRATIC PROGRAMMING ACTIVE SET METHODS
        QI - QUADRATIC PROGRAMMING INTERIOR POINT METHODS
        MN - MODIFIED NEWTON METHODS
    $CHECK(CLASS,'QP','QP\QI\MN\VM\CD',2,NO)
    $IF(CLASS='QI')
  $ENDIF
  $ELSE
    $HELP
      CLASS OF METHODS:
        MN - MODIFIED NEWTON METHODS
    $CHECK(CLASS,'MN','MN',2,NO)
  $ENDIF
$ELSEIF(MODEL='AM')
  $IF(HESF='D')
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          VM - VARIABLE METRIC METHODS
          BM - PROXIMAL BUNDLE METHODS
          BN - BUNDLE-NEWTON METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,'BV','HM\VM\BM\BN\BV\BW',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          BM - PROXIMAL BUNDLE METHODS
          BN - BUNDLE-NEWTON METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,'BV','VM\BM\BN\BV\BW\HM',2,NO)
    $ENDIF
$REM    $JACA='NO'
  $ELSEIF(HESF='S')
    $HELP
      CLASS OF METHODS:
        BV - PARTITIONED VARIABLE METRIC BUNDLE METHODS
        BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
             NONSMOOTH FUNCTIONS
    $CHECK(CLASS,'BV','VM\BV\BL\HM',2,NO)
  $ELSE
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
               NONSMOOTH FUNCTIONS
      $CHECK(CLASS,'BL','HM\BL',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
               NONSMOOTH FUNCTIONS
      $CHECK(CLASS,'BL','BL\HM',2,NO)
    $ENDIF
  $ENDIF
  $IF(CLASS='HM') $HESF='NO'
  $IF(CLASS='BL') $HESF='NO'
$ELSEIF(MODEL='AA')
  $IF(HESF='D')
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          VM - VARIABLE METRIC METHODS
          BM - PROXIMAL BUNDLE METHODS
          BN - BUNDLE-NEWTON METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,'BV','HM\VM\BM\BN\BV\BW',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          BM - PROXIMAL BUNDLE METHODS
          BN - BUNDLE-NEWTON METHODS
          BV - VARIABLE METRIC BUNDLE METHODS
      $CHECK(CLASS,'BV','VM\BM\BN\BV\BW\HM',2,NO)
    $ENDIF
$REM    $JACA='NO'
  $ELSEIF(HESF='S')
    $HELP
      CLASS OF METHODS:
        BV - VARIABLE METRIC BUNDLE METHODS
        BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
             NONSMOOTH FUNCTIONS
    $CHECK(CLASS,'BV','VM\BV\BL\HM',2,NO)
  $ELSE
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
               NONSMOOTH FUNCTIONS
      $CHECK(CLASS,'BL','HM\BL',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
               NONSMOOTH FUNCTIONS
      $CHECK(CLASS,'BL','BL\HM',2,NO)
    $ENDIF
  $ENDIF
  $IF(CLASS='HM') $HESF='NO'
  $IF(CLASS='BL') $HESF='NO'
$REM  $IF(CLASS='HM') $JACA='NO'
$ELSEIF(MODEL='AF')
  $IF(KSA=3)
    $IF(HESF='NO')
      $DEFAULT='BL'
      $IF(NF<50) $DEFAULT='BM'
    $ELSE
      $DEFAULT='BV'
      $IF(NF<20) $DEFAULT='BM'
    $ENDIF
    $HELP
      CLASS OF METHODS:
        VM - VARIABLE METRIC METHODS
        BM - PROXIMAL BUNDLE METHODS
        BN - BUNDLE-NEWTON METHODS
        BV - VARIABLE METRIC METHODS FOR NONSMOOTH FUNCTIONS
        BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
             NONSMOOTH FUNCTIONS
    $CHECK(CLASS,DEFAULT,'VM\BM\BN\BV\BW\BL',2,NO)
    $IF(CLASS='BM') $HESF='NO'
    $IF(CLASS='BL') $HESF='NO'
  $ELSEIF(HESF='D')
    $IF(KDA=2)
      $DEFAULT='MN'
    $ELSEIF(KCA=1)
      $DEFAULT='CD'
      $IF(NF<201) $DEFAULT='VM'
    $ELSEIF(KCA=2)
      $DEFAULT='CD'
      $IF(NF<301) $DEFAULT='VM'
    $ELSE
      $DEFAULT='CD'
      $IF(NF<401) $DEFAULT='VM'
    $ENDIF
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'HM\CD\VM\VL\VN\VP\VS\VR\MN',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          TN - TRUNCATED MODIFIED NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN',2,NO)
    $ENDIF
  $ELSEIF(HESF='B')
    $IF(KBC>0)
      $CLASS='VM'
    $ELSE
      $IF(KDA=2)
        $DEFAULT='MN'
      $ELSEIF(KCA=1)
        $DEFAULT='CD'
        $IF(NF<301) $DEFAULT='VM'
      $ELSE
        $DEFAULT='VM'
      $ENDIF
      $IF(KDA=0)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\MV',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN\MV',2,NO)
      $ENDIF
    $ENDIF
  $ELSEIF(HESF='S')
    $IF(KBC>0)
      $CLASS='VM'
    $ELSE
      $IF(KDA=2)
        $DEFAULT='MN'
      $ELSEIF(KCA=1)
        $DEFAULT='CD'
        $IF(NF<301) $DEFAULT='VM'
      $ELSE
        $DEFAULT='VM'
      $ENDIF
      $IF(KDA=0)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\MV',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN\MV',2,NO)
      $ENDIF
    $ENDIF
  $ELSE
    $IF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
      $CHECK(CLASS,'CD','HM\CD\VL\VN\VP\VS\VR',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          TN - TRUNCATED MODIFIED NEWTON METHODS
      $CHECK(CLASS,'CD','CD\VL\VN\VP\VS\VR\TN',2,NO)
    $ENDIF
  $ENDIF
  $IF(CLASS='HM') $HESF='NO'
  $IF(CLASS='CD') $HESF='NO'
  $IF(CLASS='VL') $HESF='NO'
  $IF(CLASS='VP') $HESF='NO'
  $IF(CLASS='VS') $HESF='NO'
  $IF(CLASS='VR') $HESF='NO'
  $IF(CLASS='TN') $HESF='NO'
$REM  $IF(CLASS='CD') $JACA='NO'
$REM  $IF(CLASS='HM') $JACA='NO'
$ELSEIF(MODEL='A?')
  $CHOICE=.TRUE.
  $IF(CONSTR<>'U') $CHOICE=.FALSE.
  $IF(MODEL='AQ')
  $ELSEIF(MODEL='AP')
  $ELSE
    $CHOICE=.FALSE.
  $ENDIF
  $IF($DEF(DECOMP))
    $IF(DECOMP='A') $HESF='NO'
    $IF(DECOMP='E') $HESF='NO'
    $IF(DECOMP='Q') $HESF='NO'
  $ELSEIF(NA=NF)
    $HESF='NO'
  $ENDIF
  $IF(JACA='NO') $HESF='NO'
  $IF(HESF='NO')
  $ELSE
    $IF(KDA>0) $CHOICE=.FALSE.
  $ENDIF
  $IF(KSA=3)
    $IF(HESF='NO')
      $DEFAULT='BL'
      $IF(NF<50) $DEFAULT='BM'
    $ELSE
      $DEFAULT='BV'
      $IF(NF<20) $DEFAULT='BM'
    $ENDIF
    $HELP
      CLASS OF METHODS:
        VM - VARIABLE METRIC METHODS
        BM - PROXIMAL BUNDLE METHODS
        BN - BUNDLE-NEWTON METHODS
        BV - VARIABLE METRIC METHODS FOR NONSMOOTH FUNCTIONS
        BL - LIMITED-MEMORY VARIABLE METRIC METHODS FOR
             NONSMOOTH FUNCTIONS
    $CHECK(CLASS,DEFAULT,'VM\BM\BN\BV\BW\BL',2,NO)
    $IF(CLASS='BM') $HESF='NO'
    $IF(CLASS='BL') $HESF='NO'
  $ELSEIF(HESF='D')
    $IF(NA=NF)
      $DEFAULT='QN'
    $ELSEIF(KCA=1)
      $DEFAULT='CD'
      $IF(NF<201) $DEFAULT='VM'
      $IF(NF<40) $DEFAULT='GN'
    $ELSEIF(KCA=2)
      $DEFAULT='CD'
      $IF(NF<301) $DEFAULT='VM'
      $IF(NF<60) $DEFAULT='GN'
    $ELSE
      $DEFAULT='CD'
      $IF(NF<401) $DEFAULT='VM'
      $IF(NF<80) $DEFAULT='GN'
    $ENDIF
    $IF(CHOICE)
      $IF(NA=NF)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            TN - TRUNCATED NEWTON METHODS
            QN - QUASI-NEWTON METHODS
            QB - SIMPLE QUASI-NEWTON AND BRENT METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\GN\TN\QN\QB',2,NO)
      $ELSEIF(KDA=0)
        $HELP
          CLASS OF METHODS:
            HM - HEURISTIC METHODS
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'HM\CD\VM\VL\VN\VP\VS\VR\MN\GN\QN',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VM - VARIABLE METRIC METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            MN - MODIFIED NEWTON METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN\GN\QN',2,NO)
      $ENDIF
    $ELSEIF(KDA=0)
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'HM\CD\VM\VL\VN\VP\VS\VR\MN\GN',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          TN - TRUNCATED MODIFIED NEWTON METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\TN\GN',2,NO)
    $ENDIF
  $ELSEIF(HESF='B')
    $IF(KBC>0)
      $CLASS='VM'
    $ELSE
      $DEFAULT='GN'
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\GN',2,NO)
    $ENDIF
  $ELSEIF(HESF='S')
    $IF(KBC>0)
      $CLASS='VM'
    $ELSE
      $DEFAULT='GN'
      $HELP
        CLASS OF METHODS:
          CD - CONJUGATE DIRECTION METHODS
          VM - VARIABLE METRIC METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          MN - MODIFIED NEWTON METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'CD\VM\VL\VN\VP\VS\VR\MN\GN',2,NO)
    $ENDIF
  $ELSEIF(CHOICE)
    $DEFAULT='GN'
    $IF(KDA=0)
      $DEFAULT='QN'
      $IF(NA=NF)
        $IF(JACA='NO') $DEFAULT='TN'
      $ENDIF
    $ENDIF
    $IF(JACA='S')
      $IF(NA=NF)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            TN - TRUNCATED NEWTON METHODS
            QN - QUASI-NEWTON METHODS
            QL - LIMITED QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\GN\TN\QN\QL',2,NO)
      $ELSEIF(KDA=0)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\GN\QN\QL',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\TN\GN\QN\QL',2,NO)
      $ENDIF
    $ELSEIF(JACA='D')
      $IF(NA=NF)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            TN - TRUNCATED NEWTON METHODS
            QN - QUASI-NEWTON METHODS
            QB - SIMPLE QUASI-NEWTON AND BRENT METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\GN\TN\QN\QB',2,NO)
      $ELSEIF(KDA=0)
        $HELP
          CLASS OF METHODS:
            HM - HEURISTIC METHODS
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'HM\CD\VL\VN\VP\VS\VR\GN\QN',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
            GN - MODIFIED GAUSS-NEWTON METHODS
            QN - QUASI-NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\TN\GN\QN',2,NO)
      $ENDIF
    $ELSE
      $IF(NA=NF)
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            TN - TRUNCATED NEWTON METHODS
        $CHECK(CLASS,DEFAULT,'CD\VL\VN\VP\VS\VR\TN',2,NO)
      $ELSEIF(KDA=0)
        $HELP
          CLASS OF METHODS:
            HM - HEURISTIC METHODS
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
        $CHECK(CLASS,'CD','HM\CD\VL\VN\VP\VS\VR',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
        $CHECK(CLASS,'CD','CD\VL\VN\VP\VS\VR\TN',2,NO)
      $ENDIF
    $ENDIF
  $ELSE
    $IF(JACA='NO')
      $IF(KDA=0)
        $HELP
          CLASS OF METHODS:
            HM - HEURISTIC METHODS
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
        $CHECK(CLASS,'CD','HM\CD\VL\VN\VP\VS\VR',2,NO)
      $ELSE
        $HELP
          CLASS OF METHODS:
            CD - CONJUGATE DIRECTION METHODS
            VL - LIMITED MEMORY VARIABLE METRIC METHODS
            VN - LIMITED MEMORY NEW VM METHODS
            VP - LIMITED MEMORY PRODUCT FORM VM METHODS
            VS - LIMITED MEMORY SHIFTED VM METHODS
            VR - LIMITED MEMORY REDUCED HESSIAN METHODS
            TN - TRUNCATED MODIFIED NEWTON METHODS
        $CHECK(CLASS,'CD','CD\VL\VN\VP\VS\VR\TN',2,NO)
      $ENDIF
    $ELSE
      $HELP
        CLASS OF METHODS:
          HM - HEURISTIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          VL - LIMITED MEMORY VARIABLE METRIC METHODS
          VN - LIMITED MEMORY NEW VM METHODS
          VP - LIMITED MEMORY PRODUCT FORM VM METHODS
          VS - LIMITED MEMORY SHIFTED VM METHODS
          VR - LIMITED MEMORY REDUCED HESSIAN METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,GN,'HM\CD\VL\VN\VP\VS\VR\GN',2,NO)
    $ENDIF
  $ENDIF
  $IF(CLASS='HM') $HESF='NO'
  $IF(CLASS='CD') $HESF='NO'
  $IF(CLASS='VL') $HESF='NO'
  $IF(CLASS='VP') $HESF='NO'
  $IF(CLASS='VS') $HESF='NO'
  $IF(CLASS='VR') $HESF='NO'
  $IF(CLASS='TN') $HESF='NO'
  $IF(CLASS='QN') $HESF='NO'
  $IF(CLASS='QL') $HESF='NO'
  $IF(CLASS='QB') $HESF='NO'
  $IF(CLASS='BM') $HESF='NO'
$REM  $IF(CLASS='CD') $JACA='NO'
$REM  $IF(CLASS='HM') $JACA='NO'
$REM  $IF(CLASS='TN') $JACA='NO'
$ELSEIF(MODEL='DF')
  $IF(NC>NCL)
    $CLASS='SQ'
  $ELSEIF(HESF='NO')
    $CLASS='CD'
  $ELSEIF(HESF='D')
    $DEFAULT='VM'
    $HELP
      CLASS OF METHODS:
        VM - VARIABLE METRIC METHODS
        CD - CONJUGATE DIRECTION METHODS
    $CHECK(CLASS,DEFAULT,'VM\CD',2,NO)
  $ENDIF
$ELSEIF(MODEL='DQ')
  $IF(NC>NCL)
    $CLASS='SQ'
  $ELSEIF(HESF='NO')
    $CLASS='CD'
  $ELSEIF(HESF='D')
    $DEFAULT='VM'
    $IF(KDE>0) $DEFAULT='GN'
    $IF(KDY>0) $DEFAULT='GN'
    $IF(DEFAULT='VM')
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          CD - CONJUGATE DIRECTION METHODS
      $CHECK(CLASS,DEFAULT,'VM\CD',2,NO)
    $ELSE
      $HELP
        CLASS OF METHODS:
          VM - VARIABLE METRIC METHODS
          CD - CONJUGATE DIRECTION METHODS
          GN - MODIFIED GAUSS-NEWTON METHODS
      $CHECK(CLASS,DEFAULT,'VM\CD\GN',2,NO)
    $ENDIF
  $ENDIF
$ENDIF
$REM $IF(CLASS='BN') $NUMDER=2
$IF(CLASS='BM') $KSF=3
$IF(CLASS='BN') $KSF=3
$IF(CLASS='BV') $KSF=3
$IF(CLASS='BW') $KSF=3
$IF(CLASS='BL') $KSF=3

$ADD(SINID)
  WRITE(3,'(/''PROBLEM: NEXT ='',I8)') NEXT
$ENDADD
$IF($DEF(NF))
  $IF(NF>0)
    $IF(PATTERN='YES') $SUBST('UOPATF')
    $ADD(SINID)
      IF (NF.GT.$NF) THEN
      CALL UOERR2('UZLMIN',80,NF,$NF)
      CALL UOERR4
      ITERM=-80
      TXFU='LACK SPC'
      ENDIF
      WRITE(3,'(''NUMBER OF VARIABLES:        NF  ='',I8)') NF
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(NA))
  $IF(NA>0)
    $IF(PATTERN='YES') $SUBST('UOPATA')
    $ADD(SINID)
      IF (NA.GT.$NA) THEN
      CALL UOERR2('UZLMIN',81,NA,$NA)
      CALL UOERR4
      ITERM=-81
      TXFU='LACK SPC'
      ENDIF
      WRITE(3,'(''NUMBER OF FUNCTIONS:        NA  ='',I8)') NA
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(JACA))
  $IF(JACA='S')
    $ADD(SINID)
      MA=IAG(NA+1)-1
      IF (MA.GT.$MA) THEN
      CALL UOERR2('UZLMIN',78,MA,$MA)
      CALL UOERR4
      ITERM=-78
      TXFU='LACK SPC'
      ELSE
      $IHLP=1
      $IF(MODEL='AM')
        $IF(FORM='SI') $IHLP=0
        $IF(FORM='SF') $IHLP=0
      $ENDIF
      $IF(MODEL='AA')
        $IF(FORM='SE') $IHLP=0
        $IF(FORM='SI') $IHLP=0
        $IF(FORM='SF') $IHLP=0
      $ENDIF
      $IF(IHLP=0)
      $ELSEIF(NA>NAL)
        $IF(HESF='B') $SUBST('UFSET2')
        $IF(HESF='S') $SUBST('UFSET3')
      $ENDIF
      ENDIF
      WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MA  ='',I8)') MA
      IF (MHA.GT.0) WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MHA ='',I8)')&
      MHA
$REM  IF (MAH.GT.0) WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MAH ='',I8)')&
$REM  MAH
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(NC))
  $IF(NC>0)
    $IF(PATTERN='YES') $SUBST('UOPATC')
    $ADD(SINID)
      IF (NC.GT.$NC) THEN
      CALL UOERR2('UZLMIN',82,NC,$NC)
      CALL UOERR4
      ITERM=-82
      TXFU='LACK SPC'
      ENDIF
      WRITE(3,'(''NUMBER OF CONSTRAINTS:      NC  ='',I8)') NC
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(JACC))
  $IF(JACC='S')
    $ADD(SINID)
      MC=ICG(NC+1)-1
      IF (MC.GT.$MC) THEN
      CALL UOERR2('UZLMIN',79,MC,$MC)
      CALL UOERR4
      ITERM=-79
      TXFU='LACK SPC'
      ELSE
      $IHLP=1
      $IF(MODEL='AM')
        $IF(FORM='SI') $IHLP=0
        $IF(FORM='SF') $IHLP=0
      $ENDIF
      $IF(MODEL='AA')
        $IF(FORM='SI') $IHLP=0
        $IF(FORM='SF') $IHLP=0
      $ENDIF
      $IF(IHLP=0)
      $ELSE
$REM      $IF(NC>NCL)
        $IF(HESF='S')
          WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: M   ='',I8)') IH(NF+1)-1
          $SUBST('UFSET5')
        $ENDIF
      $ENDIF
      ENDIF
      WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MC  ='',I8)') MC
      IF (MHC.GT.0) WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MHC ='',I8)')&
      MHC
      IF (MCH.GT.0) WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: MCH ='',I8)')&
      MCH
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(NCC))
  $IF(NCC>0)
    $ADD(SINID)
      IF (NCC.GT.$NCC) THEN
      CALL UOERR2('UZLMIN',82,NCC,$NCC)
      CALL UOERR4
      ITERM=-82
      TXFU='LACK SPC'
      ENDIF
      WRITE(3,'(''NUMBER OF COMP CONSTRAINTS: NCC ='',I8)') NCC
      $SUBST('UCCST1')
    $ENDADD
  $ENDIF
$ENDIF
$IF($DEF(HESF))
  $IF(HESF='S')
    $ADD(SINID)
      IF (IH(NF+1)-1.GT.$M) THEN
      CALL UOERR2('UZLMIN',75,IH(NF+1)-1,$M)
      CALL UOERR4
      ITERM=-75
      ENDIF
      WRITE(3,'(''NUMBER OF NONZERO ELEMENTS: M   ='',I8)') IH(NF+1)-1
    $ENDADD
  $ENDIF
$ENDIF
$IF(NORMF<>0) $SUBST('UYNOR1')
$IF(NORMA<>0) $SUBST('UANOR1')
$IF(NORMC<>0) $SUBST('UCNOR1')
$INDEX='0'
$IF(HESF='D')
  $M='$NF*($NF+1)/2'
  $ADD(SINID)
    M=NF*(NF+1)/2
  $ENDADD
$ENDIF

$IF($DEF(JACA))
  $IF(JACA='S')
    $ADD(SINIT)
      CALL UXVINS(NA+1,1,IAG)
    $ENDADD
  $ENDIF
  $IF(JACA='D')
    $IF(NAL>0)
      $ADD(SINIT)
        CALL UXVSET(NF*NAL,ZERO,AG)
      $ENDADD
    $ENDIF
  $ENDIF
$ENDIF
$IF($DEF(JACC))
  $IF(JACC='S')
    $ADD(SINIT)
      CALL UXVINS(NC+1,1,ICG)
    $ENDADD
  $ENDIF
  $IF(JACC='D')
    $IF(NCL>0)
      $ADD(SINIT)
        CALL UXVSET(NF*NCL,ZERO,CG)
      $ENDADD
    $ENDIF
  $ENDIF
$ENDIF

$IF(EXTREM='G')
  $ADD(INTEGER,'\NOUTS\MOUTS')
  NOUTS=NOUT
  MOUTS=MOUT
  NOUT=0
  IF (MOUT.NE.0) MOUT=SIGN(MIN(ABS(MOUT)-1,2),MOUT)
$ENDIF
$IF($DEF(FORM))
$ELSE
  $FORM='NO'
$ENDIF
$IF(FORM='SL')
  $IF(MODEL='AM')
    $IF(JACA='NO') $JACA='D'
    $IF(CLASS='MN')
      $SUBST('U2M$(JACA)U1')
    $ELSE
      $SUBST('U1M$(JACA)U1')
    $ENDIF
  $ENDIF
$ELSEIF(FORM='SQ')
  $IF(MODEL='AM')
    $IF(JACA='NO') $JACA='D'
    $IF(CLASS='VM')
      $SUBST('U1M$(JACA)N1')
    $ELSE
      $SUBST('U2M$(JACA)N1')
    $ENDIF
  $ELSEIF(MODEL='AA')
    $IF(JACA='NO') $JACA='D'
    $IF(CLASS='VM')
      $SUBST('U1A$(JACA)N1')
    $ELSE
      $SUBST('U2A$(JACA)N1')
    $ENDIF
  $ELSE
    $IF(CLASS='VM')
      $SUBST('U1F$(HESF)N1')
    $ELSE
      $SUBST('U2F$(HESF)N1')
    $ENDIF
  $ENDIF
$ELSEIF(FORM='SM')
  $IF(MODEL='AM')
    $IF(NC=0)
      $IF(CLASS='VM')
        $SUBST('U1MSU2')
      $ELSE
        $SUBST('U2MSU2')
      $ENDIF
    $ENDIF
  $ELSEIF(MODEL='AA')
    $IF(NC=0)
      $IF(CLASS='VM')
        $SUBST('U1ASU2')
      $ELSE
        $SUBST('U2ASU2')
      $ENDIF
    $ENDIF
  $ELSE
    $SUBST('U1F$(HESF)N3')
  $ENDIF
$ELSEIF(FORM='SE')
  $IF(MODEL='AA')
    $IF(CLASS='VM')
      $SUBST('U1ASE1')
    $ELSEIF(CLASS='VL')
      $SUBST('U1ASE2')
    $ELSE
      $SUBST('U2ASE1')
    $ENDIF
  $ELSE  
    $IF(CLASS='VM')
      $IF(HESF='D')
        $SUBST('U1FSE2')
      $ELSE
        $SUBST('U1FSE1')
      $ENDIF
    $ELSEIF(CLASS='VL')
      $SUBST('U1FSE2')
    $ELSEIF(CLASS='TN')
      $SUBST('U1FSE3')
    $ELSE
      $SUBST('U2FSE1')
    $ENDIF
  $ENDIF 
$ELSEIF(FORM='SI')
  $IF(NCC>0)
$REM    $IF(COMPL='P')
      $IF(CLASS='VM')
        $IF(HESF='D')
          $SUBST('U1$(COMPL)$(FORM)2')
        $ELSE
          $SUBST('U1$(COMPL)$(FORM)1')
        $ENDIF
      $ELSEIF(CLASS='VL')
        $SUBST('U1$(COMPL)$(FORM)2')
      $ELSEIF(CLASS='TN')
        $SUBST('U1$(COMPL)$(FORM)3')
      $ELSE
        $SUBST('U2$(COMPL)$(FORM)1')
      $ENDIF
$REM    $ENDIF
  $ELSE
    $IF(MODEL='AM')
      $IF(CLASS='VM')
        $SUBST('U1MSI1')
      $ELSEIF(CLASS='VL')
        $SUBST('U1MSI2')
      $ELSE
        $SUBST('U2MSI1')
      $ENDIF
    $ELSEIF(MODEL='AA')
      $IF(CLASS='VM')
        $SUBST('U1ASI1')
      $ELSEIF(CLASS='VL')
        $SUBST('U1ASI2')
      $ELSE
        $SUBST('U2ASI1')
      $ENDIF
    $ELSE
      $IF(CLASS='VM')
        $IF(HESF='D')
          $SUBST('U1FSI2')
        $ELSE
          $SUBST('U1FSI1')
        $ENDIF
      $ELSEIF(CLASS='VL')
        $SUBST('U1FSI2')
      $ELSEIF(CLASS='TN')
        $SUBST('U1FSI3')
      $ELSE
        $SUBST('U2FSI1')
      $ENDIF
    $ENDIF
  $ENDIF
$ELSEIF(FORM='SF')
  $IF(MODEL='AM')
    $IF(CLASS='VM')
      $SUBST('U1MSI1')
    $ELSEIF(CLASS='VL')
      $SUBST('U1MSI2')
    $ELSE
      $SUBST('U2MSI1')
    $ENDIF
  $ELSEIF(MODEL='AA')
    $IF(CLASS='VM')
      $SUBST('U1ASI1')
    $ELSEIF(CLASS='VL')
      $SUBST('U1ASI2')
    $ELSE
      $SUBST('U2ASI1')
    $ENDIF
  $ELSE
    $IF(CLASS='VM')
      $IF(HESF='D')
        $SUBST('U1FSF2')
      $ELSE
        $SUBST('U1FSF1')
      $ENDIF
    $ELSEIF(CLASS='VL')
      $SUBST('U1FSF2')
    $ELSEIF(CLASS='TN')
      $SUBST('U1FSF3')
    $ELSE
      $SUBST('U2FSF1')
    $ENDIF
  $ENDIF
$ELSEIF(FORM='SS')
  $IF(CLASS='VM')
    $SUBST('U1FSS1')
  $ELSEIF(CLASS='VL')
    $SUBST('U1FSS2')
  $ELSE
    $SUBST('U2FSS1')
  $ENDIF
$ELSEIF(FORM='SN')
  $IF(CLASS='VM')
    $SUBST('U1FSP2')
  $ELSE
    $SUBST('U2FSP2')
    $ENDIF
$ELSEIF(FORM='SP')
  $IF(MODEL='AM')
    $IF(CLASS='VM')
      $SUBST('U1MSU1')
    $ELSE
      $SUBST('U2MSU1')
    $ENDIF
  $ELSEIF(MODEL='AA')
    $IF(CLASS='VM')
      $SUBST('U1ASU1')
    $ELSE
      $SUBST('U2ASU1')
    $ENDIF
  $ELSE
    $IF(CLASS='VM')
      $SUBST('U1FSP1')
    $ELSE
      $SUBST('U2FSP1')
    $ENDIF
  $ENDIF
$ELSE
  $IF(CLASS='LP')
    $SUBST('U1L$(JACC)L1')
  $ELSEIF(CLASS='LI')
    $SUBST('U1L$(JACC)L2')
  $ELSEIF(CLASS='QP')
    $SUBST('U1Q$(JACC)L1')
  $ELSEIF(CLASS='QI')
    $SUBST('U1Q$(JACC)L2')
  $ELSEIF(CLASS='VM')
    $IF(HESF='D')
      $SUBST('U1F$(HESF)U1')
    $ELSEIF(KBC>0)
$REM      $IHLP='S'
$REM      $IF(MODEL='A?') $IHLP='B'
$REM      $SUBST('U1F$(IHLP)L1')
      $SUBST('U1FSL1')
    $ELSE
      $SUBST('U1F$(HESF)U1')
    $ENDIF
  $ELSEIF(CLASS='VL')
    $SUBST('U1FLU2')
  $ELSEIF(CLASS='VR')
    $SUBST('U1FLU3')
  $ELSEIF(CLASS='VS')
    $SUBST('U1FLU4')
  $ELSEIF(CLASS='VP')
    $SUBST('U1FLU5')
  $ELSEIF(CLASS='VN')
    $SUBST('U1FLU6')
  $ELSEIF(CLASS='CD')
    $IF(KBC>0)
      $IF(JACC='S')
        $SUBST('U1FSL2')
      $ELSE
        $SUBST('U1FDU2')
      $ENDIF
    $ELSE
      $SUBST('U1FLU1')
    $ENDIF
  $ELSEIF(CLASS='MN')
    $IF(MODEL='AA')
      $SUBST('U2F$(HESF)U5')
    $ELSEIF(HESF='D')
      $SUBST('U2F$(HESF)U1')
    $ELSEIF(KBC>0)
      $IHLP='S'
      $IF(MODEL='A?') $IHLP='B'
      $SUBST('U2F$(IHLP)L1')
    $ELSE
      $SUBST('U2F$(HESF)U1')
    $ENDIF
  $ELSEIF(CLASS='TN')
    $IF(NA=NF)
      $SUBST('U0SSU3')
    $ELSE
      $SUBST('U1FSU2')
    $ENDIF
  $ELSEIF(CLASS='BM')
    $SUBST('U1FDU3')
  $ELSEIF(CLASS='BN')
    $SUBST('U2FDU3')
  $ELSEIF(CLASS='BW')
    $SUBST('U1FDU4')
  $ELSEIF(CLASS='BV')
    $SUBST('U1F$(HESF)U5')
  $ELSEIF(CLASS='BL')
    $SUBST('U1FLU7')
  $ELSEIF(CLASS='GN')
    $IF(HESF='NO')
      $SUBST('U1S$(JACA)U1')
    $ELSE
      $SUBST('U2S$(HESF)U1')
    $ENDIF
  $ELSEIF(CLASS='DE')
    $SUBST('U1SDU2')
  $ELSEIF(CLASS='QN')
    $SUBST('U0S$(JACA)U1')
  $ELSEIF(CLASS='QL')
    $SUBST('U0SSU2')
  $ELSEIF(CLASS='QB')
    $SUBST('U0SDU2')
  $ELSEIF(CLASS='HM')
    $SUBST('U0FDU1')
  $ENDIF
$ENDIF
$IF(EXTREM='G')
  NOUT=NOUTS
  MOUT=MOUTS
$ENDIF

